#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "managedogrerendertexturepass.h"
#include "DEMFinalGatheringPass.h"

DEMFinalGatheringPass::DEMFinalGatheringPass(Root* mRoot)
:ManagedOgreRenderTexturePass(mRoot,ManagedOgreRenderTexturePass::noRenderTargetName,1,1)
{
	setMaterialName("EnvMap/EnvMapMaterial");
}

DEMFinalGatheringPass::~DEMFinalGatheringPass(void)
{

}

void DEMFinalGatheringPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetVector3("g_EyePos",renderTargets.at(0)->getViewport(0)->getCamera()->getPosition());
	effectWrapper->SetVector3("g_EnvMapPos",this->envMapPosition);
	effectWrapper->SetVector3("g_DiffuseColor",this->diffuseColor);
}

void DEMFinalGatheringPass::onRenderEnd(NameValuePairList* namedParams){
	effectWrapper->EndPass();
}

void DEMFinalGatheringPass::setEnvMapPosition(Vector3 envMapPosition){
	this->envMapPosition=envMapPosition;
}

void DEMFinalGatheringPass::setDiffuseColor(Vector3 diffuseColor){
	this->diffuseColor=diffuseColor;
}

void DEMFinalGatheringPass::update(){
}