//	author:	Barnabas Aszodi (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "VRMRenderDepthBufferMapPass.h"


VRMRenderDepthBufferMapPass::VRMRenderDepthBufferMapPass(
			Root* mRoot,const String& renderTextureName,unsigned int width,unsigned int height,
		 	TextureType texType, PixelFormat internalFormat,
			const NameValuePairList *miscParams,
			bool fullScreenQuadRenderer):ManagedOgreRenderTexturePass(mRoot,renderTextureName,width,height,texType,internalFormat,miscParams,fullScreenQuadRenderer)
{
	effectWrapper->createMaterial("RenderRoomColorDistance");
}

void VRMRenderDepthBufferMapPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetVertexProgramParameters();
	effectWrapper->SetMatrix("g_mLightViewTexBias",g_mLightViewTexBias);
	effectWrapper->SetMatrix("g_mWorldViewProj",g_mWorldViewProj);
}


void VRMRenderDepthBufferMapPass::onRenderEnd(NameValuePairList* namedParams)
{
	effectWrapper->EndPass();
}

Matrix4 VRMRenderDepthBufferMapPass::getLightViewTexBias()
{
	return g_mLightViewTexBias;
}

void VRMRenderDepthBufferMapPass::setLightViewTexBias( Matrix4 matrix4 )
{
	g_mLightViewTexBias = matrix4;
}

Matrix4 VRMRenderDepthBufferMapPass::getWorldViewProj()
{
	return g_mWorldViewProj;
}

void VRMRenderDepthBufferMapPass::setWorldViewProj( Matrix4 matrix4 )
{
	g_mWorldViewProj = matrix4;
}